<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfBestellPosition ArrayType
 * @subpackage Arrays
 */
class ArrayOfBestellPosition extends AbstractStructArrayBase
{
    /**
     * The BestellPosition
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\BestellPosition[]
     */
    public $BestellPosition;
    /**
     * Constructor method for ArrayOfBestellPosition
     * @uses ArrayOfBestellPosition::setBestellPosition()
     * @param \StructType\BestellPosition[] $bestellPosition
     */
    public function __construct(array $bestellPosition = array())
    {
        $this
            ->setBestellPosition($bestellPosition);
    }
    /**
     * Get BestellPosition value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\BestellPosition[]|null
     */
    public function getBestellPosition()
    {
        return isset($this->BestellPosition) ? $this->BestellPosition : null;
    }
    /**
     * This method is responsible for validating the values passed to the setBestellPosition method
     * This method is willingly generated in order to preserve the one-line inline validation within the setBestellPosition method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateBestellPositionForArrayConstraintsFromSetBestellPosition(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfBestellPositionBestellPositionItem) {
            // validation for constraint: itemType
            if (!$arrayOfBestellPositionBestellPositionItem instanceof \StructType\BestellPosition) {
                $invalidValues[] = is_object($arrayOfBestellPositionBestellPositionItem) ? get_class($arrayOfBestellPositionBestellPositionItem) : sprintf('%s(%s)', gettype($arrayOfBestellPositionBestellPositionItem), var_export($arrayOfBestellPositionBestellPositionItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The BestellPosition property can only contain items of type \StructType\BestellPosition, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set BestellPosition value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\BestellPosition[] $bestellPosition
     * @return \ArrayType\ArrayOfBestellPosition
     */
    public function setBestellPosition(array $bestellPosition = array())
    {
        // validation for constraint: array
        if ('' !== ($bestellPositionArrayErrorMessage = self::validateBestellPositionForArrayConstraintsFromSetBestellPosition($bestellPosition))) {
            throw new \InvalidArgumentException($bestellPositionArrayErrorMessage, __LINE__);
        }
        if (is_null($bestellPosition) || (is_array($bestellPosition) && empty($bestellPosition))) {
            unset($this->BestellPosition);
        } else {
            $this->BestellPosition = $bestellPosition;
        }
        return $this;
    }
    /**
     * Add item to BestellPosition value
     * @throws \InvalidArgumentException
     * @param \StructType\BestellPosition $item
     * @return \ArrayType\ArrayOfBestellPosition
     */
    public function addToBestellPosition(\StructType\BestellPosition $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\BestellPosition) {
            throw new \InvalidArgumentException(sprintf('The BestellPosition property can only contain items of type \StructType\BestellPosition, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->BestellPosition[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\BestellPosition|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\BestellPosition|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\BestellPosition|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\BestellPosition|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\BestellPosition|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string BestellPosition
     */
    public function getAttributeName()
    {
        return 'BestellPosition';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfBestellPosition
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
