<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDispatch_Position ArrayType
 * @subpackage Arrays
 */
class ArrayOfDispatch_Position extends AbstractStructArrayBase
{
    /**
     * The Dispatch_Position
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Dispatch_Position[]
     */
    public $Dispatch_Position;
    /**
     * Constructor method for ArrayOfDispatch_Position
     * @uses ArrayOfDispatch_Position::setDispatch_Position()
     * @param \StructType\Dispatch_Position[] $dispatch_Position
     */
    public function __construct(array $dispatch_Position = array())
    {
        $this
            ->setDispatch_Position($dispatch_Position);
    }
    /**
     * Get Dispatch_Position value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Dispatch_Position[]|null
     */
    public function getDispatch_Position()
    {
        return isset($this->Dispatch_Position) ? $this->Dispatch_Position : null;
    }
    /**
     * This method is responsible for validating the values passed to the setDispatch_Position method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDispatch_Position method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDispatch_PositionForArrayConstraintsFromSetDispatch_Position(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfDispatch_PositionDispatch_PositionItem) {
            // validation for constraint: itemType
            if (!$arrayOfDispatch_PositionDispatch_PositionItem instanceof \StructType\Dispatch_Position) {
                $invalidValues[] = is_object($arrayOfDispatch_PositionDispatch_PositionItem) ? get_class($arrayOfDispatch_PositionDispatch_PositionItem) : sprintf('%s(%s)', gettype($arrayOfDispatch_PositionDispatch_PositionItem), var_export($arrayOfDispatch_PositionDispatch_PositionItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Dispatch_Position property can only contain items of type \StructType\Dispatch_Position, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Dispatch_Position value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\Dispatch_Position[] $dispatch_Position
     * @return \ArrayType\ArrayOfDispatch_Position
     */
    public function setDispatch_Position(array $dispatch_Position = array())
    {
        // validation for constraint: array
        if ('' !== ($dispatch_PositionArrayErrorMessage = self::validateDispatch_PositionForArrayConstraintsFromSetDispatch_Position($dispatch_Position))) {
            throw new \InvalidArgumentException($dispatch_PositionArrayErrorMessage, __LINE__);
        }
        if (is_null($dispatch_Position) || (is_array($dispatch_Position) && empty($dispatch_Position))) {
            unset($this->Dispatch_Position);
        } else {
            $this->Dispatch_Position = $dispatch_Position;
        }
        return $this;
    }
    /**
     * Add item to Dispatch_Position value
     * @throws \InvalidArgumentException
     * @param \StructType\Dispatch_Position $item
     * @return \ArrayType\ArrayOfDispatch_Position
     */
    public function addToDispatch_Position(\StructType\Dispatch_Position $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Dispatch_Position) {
            throw new \InvalidArgumentException(sprintf('The Dispatch_Position property can only contain items of type \StructType\Dispatch_Position, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Dispatch_Position[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\Dispatch_Position|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\Dispatch_Position|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\Dispatch_Position|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\Dispatch_Position|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\Dispatch_Position|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Dispatch_Position
     */
    public function getAttributeName()
    {
        return 'Dispatch_Position';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfDispatch_Position
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
