<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfRetoure ArrayType
 * @subpackage Arrays
 */
class ArrayOfRetoure extends AbstractStructArrayBase
{
    /**
     * The Retoure
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Retoure[]
     */
    public $Retoure;
    /**
     * Constructor method for ArrayOfRetoure
     * @uses ArrayOfRetoure::setRetoure()
     * @param \StructType\Retoure[] $retoure
     */
    public function __construct(array $retoure = array())
    {
        $this
            ->setRetoure($retoure);
    }
    /**
     * Get Retoure value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Retoure[]|null
     */
    public function getRetoure()
    {
        return isset($this->Retoure) ? $this->Retoure : null;
    }
    /**
     * This method is responsible for validating the values passed to the setRetoure method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRetoure method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRetoureForArrayConstraintsFromSetRetoure(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfRetoureRetoureItem) {
            // validation for constraint: itemType
            if (!$arrayOfRetoureRetoureItem instanceof \StructType\Retoure) {
                $invalidValues[] = is_object($arrayOfRetoureRetoureItem) ? get_class($arrayOfRetoureRetoureItem) : sprintf('%s(%s)', gettype($arrayOfRetoureRetoureItem), var_export($arrayOfRetoureRetoureItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Retoure property can only contain items of type \StructType\Retoure, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Retoure value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\Retoure[] $retoure
     * @return \ArrayType\ArrayOfRetoure
     */
    public function setRetoure(array $retoure = array())
    {
        // validation for constraint: array
        if ('' !== ($retoureArrayErrorMessage = self::validateRetoureForArrayConstraintsFromSetRetoure($retoure))) {
            throw new \InvalidArgumentException($retoureArrayErrorMessage, __LINE__);
        }
        if (is_null($retoure) || (is_array($retoure) && empty($retoure))) {
            unset($this->Retoure);
        } else {
            $this->Retoure = $retoure;
        }
        return $this;
    }
    /**
     * Add item to Retoure value
     * @throws \InvalidArgumentException
     * @param \StructType\Retoure $item
     * @return \ArrayType\ArrayOfRetoure
     */
    public function addToRetoure(\StructType\Retoure $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Retoure) {
            throw new \InvalidArgumentException(sprintf('The Retoure property can only contain items of type \StructType\Retoure, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Retoure[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\Retoure|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\Retoure|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\Retoure|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\Retoure|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\Retoure|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Retoure
     */
    public function getAttributeName()
    {
        return 'Retoure';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfRetoure
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
