<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfRetourepositionen ArrayType
 * @subpackage Arrays
 */
class ArrayOfRetourepositionen extends AbstractStructArrayBase
{
    /**
     * The Retourepositionen
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Retourepositionen[]
     */
    public $Retourepositionen;
    /**
     * Constructor method for ArrayOfRetourepositionen
     * @uses ArrayOfRetourepositionen::setRetourepositionen()
     * @param \StructType\Retourepositionen[] $retourepositionen
     */
    public function __construct(array $retourepositionen = array())
    {
        $this
            ->setRetourepositionen($retourepositionen);
    }
    /**
     * Get Retourepositionen value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Retourepositionen[]|null
     */
    public function getRetourepositionen()
    {
        return isset($this->Retourepositionen) ? $this->Retourepositionen : null;
    }
    /**
     * This method is responsible for validating the values passed to the setRetourepositionen method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRetourepositionen method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRetourepositionenForArrayConstraintsFromSetRetourepositionen(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfRetourepositionenRetourepositionenItem) {
            // validation for constraint: itemType
            if (!$arrayOfRetourepositionenRetourepositionenItem instanceof \StructType\Retourepositionen) {
                $invalidValues[] = is_object($arrayOfRetourepositionenRetourepositionenItem) ? get_class($arrayOfRetourepositionenRetourepositionenItem) : sprintf('%s(%s)', gettype($arrayOfRetourepositionenRetourepositionenItem), var_export($arrayOfRetourepositionenRetourepositionenItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Retourepositionen property can only contain items of type \StructType\Retourepositionen, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Retourepositionen value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\Retourepositionen[] $retourepositionen
     * @return \ArrayType\ArrayOfRetourepositionen
     */
    public function setRetourepositionen(array $retourepositionen = array())
    {
        // validation for constraint: array
        if ('' !== ($retourepositionenArrayErrorMessage = self::validateRetourepositionenForArrayConstraintsFromSetRetourepositionen($retourepositionen))) {
            throw new \InvalidArgumentException($retourepositionenArrayErrorMessage, __LINE__);
        }
        if (is_null($retourepositionen) || (is_array($retourepositionen) && empty($retourepositionen))) {
            unset($this->Retourepositionen);
        } else {
            $this->Retourepositionen = $retourepositionen;
        }
        return $this;
    }
    /**
     * Add item to Retourepositionen value
     * @throws \InvalidArgumentException
     * @param \StructType\Retourepositionen $item
     * @return \ArrayType\ArrayOfRetourepositionen
     */
    public function addToRetourepositionen(\StructType\Retourepositionen $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Retourepositionen) {
            throw new \InvalidArgumentException(sprintf('The Retourepositionen property can only contain items of type \StructType\Retourepositionen, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Retourepositionen[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\Retourepositionen|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\Retourepositionen|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\Retourepositionen|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\Retourepositionen|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\Retourepositionen|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Retourepositionen
     */
    public function getAttributeName()
    {
        return 'Retourepositionen';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfRetourepositionen
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
