<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSetartikel ArrayType
 * @subpackage Arrays
 */
class ArrayOfSetartikel extends AbstractStructArrayBase
{
    /**
     * The setartikel
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Setartikel[]
     */
    public $setartikel;
    /**
     * Constructor method for ArrayOfSetartikel
     * @uses ArrayOfSetartikel::setSetartikel()
     * @param \StructType\Setartikel[] $setartikel
     */
    public function __construct(array $setartikel = array())
    {
        $this
            ->setSetartikel($setartikel);
    }
    /**
     * Get setartikel value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Setartikel[]|null
     */
    public function getSetartikel()
    {
        return isset($this->setartikel) ? $this->setartikel : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSetartikel method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSetartikel method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSetartikelForArrayConstraintsFromSetSetartikel(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSetartikelSetartikelItem) {
            // validation for constraint: itemType
            if (!$arrayOfSetartikelSetartikelItem instanceof \StructType\Setartikel) {
                $invalidValues[] = is_object($arrayOfSetartikelSetartikelItem) ? get_class($arrayOfSetartikelSetartikelItem) : sprintf('%s(%s)', gettype($arrayOfSetartikelSetartikelItem), var_export($arrayOfSetartikelSetartikelItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The setartikel property can only contain items of type \StructType\Setartikel, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set setartikel value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\Setartikel[] $setartikel
     * @return \ArrayType\ArrayOfSetartikel
     */
    public function setSetartikel(array $setartikel = array())
    {
        // validation for constraint: array
        if ('' !== ($setartikelArrayErrorMessage = self::validateSetartikelForArrayConstraintsFromSetSetartikel($setartikel))) {
            throw new \InvalidArgumentException($setartikelArrayErrorMessage, __LINE__);
        }
        if (is_null($setartikel) || (is_array($setartikel) && empty($setartikel))) {
            unset($this->setartikel);
        } else {
            $this->setartikel = $setartikel;
        }
        return $this;
    }
    /**
     * Add item to setartikel value
     * @throws \InvalidArgumentException
     * @param \StructType\Setartikel $item
     * @return \ArrayType\ArrayOfSetartikel
     */
    public function addToSetartikel(\StructType\Setartikel $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Setartikel) {
            throw new \InvalidArgumentException(sprintf('The setartikel property can only contain items of type \StructType\Setartikel, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->setartikel[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\Setartikel|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\Setartikel|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\Setartikel|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\Setartikel|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\Setartikel|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string setartikel
     */
    public function getAttributeName()
    {
        return 'setartikel';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfSetartikel
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
