<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for BestellPosition StructType
 * @subpackage Structs
 */
class BestellPosition extends AbstractStructBase
{
    /**
     * The gesamtpreis_brutto
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var float
     */
    public $gesamtpreis_brutto;
    /**
     * The freitext_artikel
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $freitext_artikel;
    /**
     * The freitextname
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $freitextname;
    /**
     * The steuer
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $steuer;
    /**
     * The einzelpreis_brutto
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $einzelpreis_brutto;
    /**
     * The sachnummer
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $sachnummer;
    /**
     * The bestellmenge
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $bestellmenge;
    /**
     * The werk
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $werk;
    /**
     * The lagerort
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $lagerort;
    /**
     * Constructor method for BestellPosition
     * @uses BestellPosition::setGesamtpreis_brutto()
     * @uses BestellPosition::setFreitext_artikel()
     * @uses BestellPosition::setFreitextname()
     * @uses BestellPosition::setSteuer()
     * @uses BestellPosition::setEinzelpreis_brutto()
     * @uses BestellPosition::setSachnummer()
     * @uses BestellPosition::setBestellmenge()
     * @uses BestellPosition::setWerk()
     * @uses BestellPosition::setLagerort()
     * @param float $gesamtpreis_brutto
     * @param bool $freitext_artikel
     * @param string $freitextname
     * @param string $steuer
     * @param string $einzelpreis_brutto
     * @param string $sachnummer
     * @param string $bestellmenge
     * @param string $werk
     * @param string $lagerort
     */
    public function __construct($gesamtpreis_brutto = null, $freitext_artikel = null, $freitextname = null, $steuer = null, $einzelpreis_brutto = null, $sachnummer = null, $bestellmenge = null, $werk = null, $lagerort = null)
    {
        $this
            ->setGesamtpreis_brutto($gesamtpreis_brutto)
            ->setFreitext_artikel($freitext_artikel)
            ->setFreitextname($freitextname)
            ->setSteuer($steuer)
            ->setEinzelpreis_brutto($einzelpreis_brutto)
            ->setSachnummer($sachnummer)
            ->setBestellmenge($bestellmenge)
            ->setWerk($werk)
            ->setLagerort($lagerort);
    }
    /**
     * Get gesamtpreis_brutto value
     * @return float
     */
    public function getGesamtpreis_brutto()
    {
        return $this->gesamtpreis_brutto;
    }
    /**
     * Set gesamtpreis_brutto value
     * @param float $gesamtpreis_brutto
     * @return \StructType\BestellPosition
     */
    public function setGesamtpreis_brutto($gesamtpreis_brutto = null)
    {
        // validation for constraint: float
        if (!is_null($gesamtpreis_brutto) && !(is_float($gesamtpreis_brutto) || is_numeric($gesamtpreis_brutto))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($gesamtpreis_brutto, true), gettype($gesamtpreis_brutto)), __LINE__);
        }
        $this->gesamtpreis_brutto = $gesamtpreis_brutto;
        return $this;
    }
    /**
     * Get freitext_artikel value
     * @return bool
     */
    public function getFreitext_artikel()
    {
        return $this->freitext_artikel;
    }
    /**
     * Set freitext_artikel value
     * @param bool $freitext_artikel
     * @return \StructType\BestellPosition
     */
    public function setFreitext_artikel($freitext_artikel = null)
    {
        // validation for constraint: boolean
        if (!is_null($freitext_artikel) && !is_bool($freitext_artikel)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($freitext_artikel, true), gettype($freitext_artikel)), __LINE__);
        }
        $this->freitext_artikel = $freitext_artikel;
        return $this;
    }
    /**
     * Get freitextname value
     * @return string|null
     */
    public function getFreitextname()
    {
        return $this->freitextname;
    }
    /**
     * Set freitextname value
     * @param string $freitextname
     * @return \StructType\BestellPosition
     */
    public function setFreitextname($freitextname = null)
    {
        // validation for constraint: string
        if (!is_null($freitextname) && !is_string($freitextname)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($freitextname, true), gettype($freitextname)), __LINE__);
        }
        $this->freitextname = $freitextname;
        return $this;
    }
    /**
     * Get steuer value
     * @return string|null
     */
    public function getSteuer()
    {
        return $this->steuer;
    }
    /**
     * Set steuer value
     * @param string $steuer
     * @return \StructType\BestellPosition
     */
    public function setSteuer($steuer = null)
    {
        // validation for constraint: string
        if (!is_null($steuer) && !is_string($steuer)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($steuer, true), gettype($steuer)), __LINE__);
        }
        $this->steuer = $steuer;
        return $this;
    }
    /**
     * Get einzelpreis_brutto value
     * @return string|null
     */
    public function getEinzelpreis_brutto()
    {
        return $this->einzelpreis_brutto;
    }
    /**
     * Set einzelpreis_brutto value
     * @param string $einzelpreis_brutto
     * @return \StructType\BestellPosition
     */
    public function setEinzelpreis_brutto($einzelpreis_brutto = null)
    {
        // validation for constraint: string
        if (!is_null($einzelpreis_brutto) && !is_string($einzelpreis_brutto)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($einzelpreis_brutto, true), gettype($einzelpreis_brutto)), __LINE__);
        }
        $this->einzelpreis_brutto = $einzelpreis_brutto;
        return $this;
    }
    /**
     * Get sachnummer value
     * @return string|null
     */
    public function getSachnummer()
    {
        return $this->sachnummer;
    }
    /**
     * Set sachnummer value
     * @param string $sachnummer
     * @return \StructType\BestellPosition
     */
    public function setSachnummer($sachnummer = null)
    {
        // validation for constraint: string
        if (!is_null($sachnummer) && !is_string($sachnummer)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sachnummer, true), gettype($sachnummer)), __LINE__);
        }
        $this->sachnummer = $sachnummer;
        return $this;
    }
    /**
     * Get bestellmenge value
     * @return string|null
     */
    public function getBestellmenge()
    {
        return $this->bestellmenge;
    }
    /**
     * Set bestellmenge value
     * @param string $bestellmenge
     * @return \StructType\BestellPosition
     */
    public function setBestellmenge($bestellmenge = null)
    {
        // validation for constraint: string
        if (!is_null($bestellmenge) && !is_string($bestellmenge)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($bestellmenge, true), gettype($bestellmenge)), __LINE__);
        }
        $this->bestellmenge = $bestellmenge;
        return $this;
    }
    /**
     * Get werk value
     * @return string|null
     */
    public function getWerk()
    {
        return $this->werk;
    }
    /**
     * Set werk value
     * @param string $werk
     * @return \StructType\BestellPosition
     */
    public function setWerk($werk = null)
    {
        // validation for constraint: string
        if (!is_null($werk) && !is_string($werk)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($werk, true), gettype($werk)), __LINE__);
        }
        $this->werk = $werk;
        return $this;
    }
    /**
     * Get lagerort value
     * @return string|null
     */
    public function getLagerort()
    {
        return $this->lagerort;
    }
    /**
     * Set lagerort value
     * @param string $lagerort
     * @return \StructType\BestellPosition
     */
    public function setLagerort($lagerort = null)
    {
        // validation for constraint: string
        if (!is_null($lagerort) && !is_string($lagerort)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($lagerort, true), gettype($lagerort)), __LINE__);
        }
        $this->lagerort = $lagerort;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\BestellPosition
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
