<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Bestellung StructType
 * @subpackage Structs
 */
class Bestellung extends AbstractStructBase
{
    /**
     * The Bestellkopf
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Bestellkopf
     */
    public $Bestellkopf;
    /**
     * The bestellpositionen
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfBestellPosition
     */
    public $bestellpositionen;
    /**
     * The rechnungsinformationen
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Rechnungsinformationen
     */
    public $rechnungsinformationen;
    /**
     * Constructor method for Bestellung
     * @uses Bestellung::setBestellkopf()
     * @uses Bestellung::setBestellpositionen()
     * @uses Bestellung::setRechnungsinformationen()
     * @param \StructType\Bestellkopf $bestellkopf
     * @param \ArrayType\ArrayOfBestellPosition $bestellpositionen
     * @param \StructType\Rechnungsinformationen $rechnungsinformationen
     */
    public function __construct(\StructType\Bestellkopf $bestellkopf = null, \ArrayType\ArrayOfBestellPosition $bestellpositionen = null, \StructType\Rechnungsinformationen $rechnungsinformationen = null)
    {
        $this
            ->setBestellkopf($bestellkopf)
            ->setBestellpositionen($bestellpositionen)
            ->setRechnungsinformationen($rechnungsinformationen);
    }
    /**
     * Get Bestellkopf value
     * @return \StructType\Bestellkopf|null
     */
    public function getBestellkopf()
    {
        return $this->Bestellkopf;
    }
    /**
     * Set Bestellkopf value
     * @param \StructType\Bestellkopf $bestellkopf
     * @return \StructType\Bestellung
     */
    public function setBestellkopf(\StructType\Bestellkopf $bestellkopf = null)
    {
        $this->Bestellkopf = $bestellkopf;
        return $this;
    }
    /**
     * Get bestellpositionen value
     * @return \ArrayType\ArrayOfBestellPosition|null
     */
    public function getBestellpositionen()
    {
        return $this->bestellpositionen;
    }
    /**
     * Set bestellpositionen value
     * @param \ArrayType\ArrayOfBestellPosition $bestellpositionen
     * @return \StructType\Bestellung
     */
    public function setBestellpositionen(\ArrayType\ArrayOfBestellPosition $bestellpositionen = null)
    {
        $this->bestellpositionen = $bestellpositionen;
        return $this;
    }
    /**
     * Get rechnungsinformationen value
     * @return \StructType\Rechnungsinformationen|null
     */
    public function getRechnungsinformationen()
    {
        return $this->rechnungsinformationen;
    }
    /**
     * Set rechnungsinformationen value
     * @param \StructType\Rechnungsinformationen $rechnungsinformationen
     * @return \StructType\Bestellung
     */
    public function setRechnungsinformationen(\StructType\Rechnungsinformationen $rechnungsinformationen = null)
    {
        $this->rechnungsinformationen = $rechnungsinformationen;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Bestellung
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
