<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Dispatch_Position StructType
 * @subpackage Structs
 */
class Dispatch_Position extends AbstractStructBase
{
    /**
     * The menge
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var float
     */
    public $menge;
    /**
     * The mhd
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $mhd;
    /**
     * The sachnummer
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $sachnummer;
    /**
     * The charge
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $charge;
    /**
     * Constructor method for Dispatch_Position
     * @uses Dispatch_Position::setMenge()
     * @uses Dispatch_Position::setMhd()
     * @uses Dispatch_Position::setSachnummer()
     * @uses Dispatch_Position::setCharge()
     * @param float $menge
     * @param string $mhd
     * @param string $sachnummer
     * @param string $charge
     */
    public function __construct($menge = null, $mhd = null, $sachnummer = null, $charge = null)
    {
        $this
            ->setMenge($menge)
            ->setMhd($mhd)
            ->setSachnummer($sachnummer)
            ->setCharge($charge);
    }
    /**
     * Get menge value
     * @return float
     */
    public function getMenge()
    {
        return $this->menge;
    }
    /**
     * Set menge value
     * @param float $menge
     * @return \StructType\Dispatch_Position
     */
    public function setMenge($menge = null)
    {
        // validation for constraint: float
        if (!is_null($menge) && !(is_float($menge) || is_numeric($menge))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($menge, true), gettype($menge)), __LINE__);
        }
        $this->menge = $menge;
        return $this;
    }
    /**
     * Get mhd value
     * @return string
     */
    public function getMhd()
    {
        return $this->mhd;
    }
    /**
     * Set mhd value
     * @param string $mhd
     * @return \StructType\Dispatch_Position
     */
    public function setMhd($mhd = null)
    {
        // validation for constraint: string
        if (!is_null($mhd) && !is_string($mhd)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($mhd, true), gettype($mhd)), __LINE__);
        }
        $this->mhd = $mhd;
        return $this;
    }
    /**
     * Get sachnummer value
     * @return string|null
     */
    public function getSachnummer()
    {
        return $this->sachnummer;
    }
    /**
     * Set sachnummer value
     * @param string $sachnummer
     * @return \StructType\Dispatch_Position
     */
    public function setSachnummer($sachnummer = null)
    {
        // validation for constraint: string
        if (!is_null($sachnummer) && !is_string($sachnummer)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sachnummer, true), gettype($sachnummer)), __LINE__);
        }
        $this->sachnummer = $sachnummer;
        return $this;
    }
    /**
     * Get charge value
     * @return string|null
     */
    public function getCharge()
    {
        return $this->charge;
    }
    /**
     * Set charge value
     * @param string $charge
     * @return \StructType\Dispatch_Position
     */
    public function setCharge($charge = null)
    {
        // validation for constraint: string
        if (!is_null($charge) && !is_string($charge)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($charge, true), gettype($charge)), __LINE__);
        }
        $this->charge = $charge;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Dispatch_Position
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
