<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for setartikel StructType
 * @subpackage Structs
 */
class Setartikel extends AbstractStructBase
{
    /**
     * The gebinde
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var float
     */
    public $gebinde;
    /**
     * The ke_per_ve
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var float
     */
    public $ke_per_ve;
    /**
     * The preis
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var float
     */
    public $preis;
    /**
     * The chargenfuehrung
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var float
     */
    public $chargenfuehrung;
    /**
     * The mandant
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $mandant;
    /**
     * The produktgruppe
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $produktgruppe;
    /**
     * The sachnummer
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $sachnummer;
    /**
     * The sachbezeichnung
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $sachbezeichnung;
    /**
     * The sachbezeichnung2
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $sachbezeichnung2;
    /**
     * The mengeneinheit
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $mengeneinheit;
    /**
     * The max_menge
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $max_menge;
    /**
     * Constructor method for setartikel
     * @uses Setartikel::setGebinde()
     * @uses Setartikel::setKe_per_ve()
     * @uses Setartikel::setPreis()
     * @uses Setartikel::setChargenfuehrung()
     * @uses Setartikel::setMandant()
     * @uses Setartikel::setProduktgruppe()
     * @uses Setartikel::setSachnummer()
     * @uses Setartikel::setSachbezeichnung()
     * @uses Setartikel::setSachbezeichnung2()
     * @uses Setartikel::setMengeneinheit()
     * @uses Setartikel::setMax_menge()
     * @param float $gebinde
     * @param float $ke_per_ve
     * @param float $preis
     * @param float $chargenfuehrung
     * @param string $mandant
     * @param string $produktgruppe
     * @param string $sachnummer
     * @param string $sachbezeichnung
     * @param string $sachbezeichnung2
     * @param string $mengeneinheit
     * @param string $max_menge
     */
    public function __construct($gebinde = null, $ke_per_ve = null, $preis = null, $chargenfuehrung = null, $mandant = null, $produktgruppe = null, $sachnummer = null, $sachbezeichnung = null, $sachbezeichnung2 = null, $mengeneinheit = null, $max_menge = null)
    {
        $this
            ->setGebinde($gebinde)
            ->setKe_per_ve($ke_per_ve)
            ->setPreis($preis)
            ->setChargenfuehrung($chargenfuehrung)
            ->setMandant($mandant)
            ->setProduktgruppe($produktgruppe)
            ->setSachnummer($sachnummer)
            ->setSachbezeichnung($sachbezeichnung)
            ->setSachbezeichnung2($sachbezeichnung2)
            ->setMengeneinheit($mengeneinheit)
            ->setMax_menge($max_menge);
    }
    /**
     * Get gebinde value
     * @return float
     */
    public function getGebinde()
    {
        return $this->gebinde;
    }
    /**
     * Set gebinde value
     * @param float $gebinde
     * @return \StructType\Setartikel
     */
    public function setGebinde($gebinde = null)
    {
        // validation for constraint: float
        if (!is_null($gebinde) && !(is_float($gebinde) || is_numeric($gebinde))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($gebinde, true), gettype($gebinde)), __LINE__);
        }
        $this->gebinde = $gebinde;
        return $this;
    }
    /**
     * Get ke_per_ve value
     * @return float
     */
    public function getKe_per_ve()
    {
        return $this->ke_per_ve;
    }
    /**
     * Set ke_per_ve value
     * @param float $ke_per_ve
     * @return \StructType\Setartikel
     */
    public function setKe_per_ve($ke_per_ve = null)
    {
        // validation for constraint: float
        if (!is_null($ke_per_ve) && !(is_float($ke_per_ve) || is_numeric($ke_per_ve))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($ke_per_ve, true), gettype($ke_per_ve)), __LINE__);
        }
        $this->ke_per_ve = $ke_per_ve;
        return $this;
    }
    /**
     * Get preis value
     * @return float
     */
    public function getPreis()
    {
        return $this->preis;
    }
    /**
     * Set preis value
     * @param float $preis
     * @return \StructType\Setartikel
     */
    public function setPreis($preis = null)
    {
        // validation for constraint: float
        if (!is_null($preis) && !(is_float($preis) || is_numeric($preis))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($preis, true), gettype($preis)), __LINE__);
        }
        $this->preis = $preis;
        return $this;
    }
    /**
     * Get chargenfuehrung value
     * @return float
     */
    public function getChargenfuehrung()
    {
        return $this->chargenfuehrung;
    }
    /**
     * Set chargenfuehrung value
     * @param float $chargenfuehrung
     * @return \StructType\Setartikel
     */
    public function setChargenfuehrung($chargenfuehrung = null)
    {
        // validation for constraint: float
        if (!is_null($chargenfuehrung) && !(is_float($chargenfuehrung) || is_numeric($chargenfuehrung))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($chargenfuehrung, true), gettype($chargenfuehrung)), __LINE__);
        }
        $this->chargenfuehrung = $chargenfuehrung;
        return $this;
    }
    /**
     * Get mandant value
     * @return string|null
     */
    public function getMandant()
    {
        return $this->mandant;
    }
    /**
     * Set mandant value
     * @param string $mandant
     * @return \StructType\Setartikel
     */
    public function setMandant($mandant = null)
    {
        // validation for constraint: string
        if (!is_null($mandant) && !is_string($mandant)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($mandant, true), gettype($mandant)), __LINE__);
        }
        $this->mandant = $mandant;
        return $this;
    }
    /**
     * Get produktgruppe value
     * @return string|null
     */
    public function getProduktgruppe()
    {
        return $this->produktgruppe;
    }
    /**
     * Set produktgruppe value
     * @param string $produktgruppe
     * @return \StructType\Setartikel
     */
    public function setProduktgruppe($produktgruppe = null)
    {
        // validation for constraint: string
        if (!is_null($produktgruppe) && !is_string($produktgruppe)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($produktgruppe, true), gettype($produktgruppe)), __LINE__);
        }
        $this->produktgruppe = $produktgruppe;
        return $this;
    }
    /**
     * Get sachnummer value
     * @return string|null
     */
    public function getSachnummer()
    {
        return $this->sachnummer;
    }
    /**
     * Set sachnummer value
     * @param string $sachnummer
     * @return \StructType\Setartikel
     */
    public function setSachnummer($sachnummer = null)
    {
        // validation for constraint: string
        if (!is_null($sachnummer) && !is_string($sachnummer)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sachnummer, true), gettype($sachnummer)), __LINE__);
        }
        $this->sachnummer = $sachnummer;
        return $this;
    }
    /**
     * Get sachbezeichnung value
     * @return string|null
     */
    public function getSachbezeichnung()
    {
        return $this->sachbezeichnung;
    }
    /**
     * Set sachbezeichnung value
     * @param string $sachbezeichnung
     * @return \StructType\Setartikel
     */
    public function setSachbezeichnung($sachbezeichnung = null)
    {
        // validation for constraint: string
        if (!is_null($sachbezeichnung) && !is_string($sachbezeichnung)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sachbezeichnung, true), gettype($sachbezeichnung)), __LINE__);
        }
        $this->sachbezeichnung = $sachbezeichnung;
        return $this;
    }
    /**
     * Get sachbezeichnung2 value
     * @return string|null
     */
    public function getSachbezeichnung2()
    {
        return $this->sachbezeichnung2;
    }
    /**
     * Set sachbezeichnung2 value
     * @param string $sachbezeichnung2
     * @return \StructType\Setartikel
     */
    public function setSachbezeichnung2($sachbezeichnung2 = null)
    {
        // validation for constraint: string
        if (!is_null($sachbezeichnung2) && !is_string($sachbezeichnung2)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sachbezeichnung2, true), gettype($sachbezeichnung2)), __LINE__);
        }
        $this->sachbezeichnung2 = $sachbezeichnung2;
        return $this;
    }
    /**
     * Get mengeneinheit value
     * @return string|null
     */
    public function getMengeneinheit()
    {
        return $this->mengeneinheit;
    }
    /**
     * Set mengeneinheit value
     * @param string $mengeneinheit
     * @return \StructType\Setartikel
     */
    public function setMengeneinheit($mengeneinheit = null)
    {
        // validation for constraint: string
        if (!is_null($mengeneinheit) && !is_string($mengeneinheit)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($mengeneinheit, true), gettype($mengeneinheit)), __LINE__);
        }
        $this->mengeneinheit = $mengeneinheit;
        return $this;
    }
    /**
     * Get max_menge value
     * @return string|null
     */
    public function getMax_menge()
    {
        return $this->max_menge;
    }
    /**
     * Set max_menge value
     * @param string $max_menge
     * @return \StructType\Setartikel
     */
    public function setMax_menge($max_menge = null)
    {
        // validation for constraint: string
        if (!is_null($max_menge) && !is_string($max_menge)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($max_menge, true), gettype($max_menge)), __LINE__);
        }
        $this->max_menge = $max_menge;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Setartikel
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
